#include <Wire.h>
#define addr                 0x08
int led = 13;
float vol[6] = {0};
void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.println("Start TEST");
  Wire.begin();
  pinMode(led, OUTPUT);
  for (int n = 0; n < 5; n++)
  {
    digitalWrite(led, LOW);
    delay(50);
    digitalWrite(led, HIGH);
    delay(50);
  }
  digitalWrite(led, LOW);
  for (int n = 0; n < 6; n++)
  {
    readRegister(addr, n);
    delay(100);
  }
}

void loop()
{
  for (int n = 0; n < 6; n++)
  {
    vol[n] = readRegister(addr, n);
    Serial.print(vol[n]);
    Serial.print("      ");
    delay(100);
  }
  delay(1000);
  Serial.println();
  Serial.println();
  show();
}



uint8_t i2c_read()
{
  return Wire.read();
}

void i2c_write(uint8_t x)
{
  Wire.write((uint8_t)x);
}

uint16_t readRegister(uint8_t i2cAddress, uint8_t channel)
{
  uint16_t data;
  uint8_t reg = 0x20;
  reg += channel;
  Wire.beginTransmission(i2cAddress);
  i2c_write(reg);
  Wire.endTransmission();
  Wire.beginTransmission(i2cAddress);
  i2c_write(reg);
  Wire.requestFrom(i2cAddress, (uint8_t)2);
  return (i2c_read() | i2c_read() << 8);
}


void show()
{
  if (vol[0] > 466 && vol[0] < 516 && vol[1] > 900 && vol[1] < 995 && vol[2] > 1368 && vol[2] < 1512 && vol[3] > 1800 && vol[3] < 1990 && vol[4] > 2271 && vol[4] < 2515 && vol[5] > 2702 && vol[5] < 2987 )
  {
    digitalWrite(led, HIGH);
    Serial.println("vol test ok");
  }
  else
  {
    digitalWrite(led, LOW);
    Serial.println("vol test fail");
  }
  while (1)
  {
    delay(1000);
  }
}
